{***************************************************************

	IMPORTANT: Please pay attention to the DEFINES below this
 					 documentation!

	WICHTIG: 	 Bitte beachten Sie die DEFINES unter dieser Dokumentation!

	IMPORTANT: Veuillez faire attention aux clauses DEFINES dans la partie documentee.

   **************************************************************
		German translation follows (deutsche bersetzung weiter unten)
   **************************************************************

   Unit Name: EuroCalc

   Author   : Robert Wachtel
 						 RWachtel@gmx.de
              http://www.mpscologne.de

   History  : V1   - October 1999
   										first release
							 V1.1 - October 1999
              					added StringLists for the countries and
              					currencies
                       added CurrencyName: string and
                       CountryName: string property to
                       TEuroCountry
              V1.2 - November 1999
              					added German strings
                       and documentation
              V1.3 - November 1999
              					added foreign country
              V1.4 - January 2000
												Christophe Foubet (http://perso.wanadoo.fr/cfoubet/)
                       	added french strings
                       Juergen Thomas added comments about TEuroCalc - see end of text
                       	(I'll try to work on it ;-)
                       Gunther Buchtala found a rounding bug

		Written and tested in Delphi 3.02

   Should work with every Delphi version 3.x and above.

   What it does:
   =============

   	TEuroCalc is a Euro calculator for up to two currencies
     	simultaneously. You can calculate Euro in member state's
       currency and vice versa. Also a third foreign country
       conversion is supported.

   Installing:
   ===========

			In the menu bar open COMPONENTS and select INSTALL COMPONENTS.
     Then install this unit with the OK button.

     Caution: Afaik Delphi 5 doesn't have the DSGNINTF.DCU package:
              Please follow the instructions in the Delphi 5 README.TXT

   Miscellaneous:
		==============

   This component is (c) copyrighted 1999-2000 by Robert Wachtel.

   This component is uncrippled PublicDomain for private use only.
                                                 ================

   For commercial use this component is uncrippled ShareWare, so
   	you have to pay the registration fee mentioned below
     to obtain the right to use this software commercially.

   If you find this component useful or want to use it
   	commercially a donation of 10 Euro (or US-$ 10)
     is appreciated:

     		Robert Wachtel
         Kyffhaeuserstr. 23
         D-50674 Koeln
         GERMANY

   With paying this registration fee you'll also get future
   	versions and bug fixes of this software via eMail
     without any charge.

   If you have any problems or suggestions please feel free
   	to contact me. If you change this software or parts of it
     please send me a copy.

		This software is provided as it is, without any kind of warranty
			given. The auther can not be held responsible for any kind of
			damage, problems etc. arised from using this product.

		You may use this software in any kind of development and redistribute
   	it freely, under the following restrictions :

			1. The origin of this software may not be mispresented, you must
   		 not claim that you wrote the original software. If you use
   		 this software in any kind of product, it would be appreciated
   		 that there in a information box, or in the documentation would
   		 be an acknowledgement like this
        			Parts Copyright  1999 by Robert Wachtel

			2. You may not have any income from distributing this source
   		 to other developers. When you use this product in a comercial
        package, the source may not be charged seperatly.

			3. This notice may not be removed from the source.

     4. If you redistribute this software (i.e. magazine cd)
     	 I ask for a copy of the distribute media.

   Credits:
   ========

   Thanks to
   	Bea for all the love
			Simon Reinhardt for his DelphiFAQ (http://pics.webset.de)
   	Lloyd Linklater for his Delphi Notes Help File
     Sven Biehl for a lot of useful hints in programming Delphi
     everyone in news://de.comp.lang.delphi.* for being a great community

   *****************************************
		German translation (deutsche bersetzung)
   *****************************************

   Unit Name: EuroCalc

   Autor    : Robert Wachtel
 						 RWachtel@gmx.de
              http://www.mpscologne.de

   History  : V1   - Oktober 1999
   										erste verffentlichte Version
							 V1.1 - Oktober 1999
              					StringLists fr die Lndernamen und Whrungen eingefgt
                       TEuroCountry mit CurrencyName: string und CountryName: string
                       Eigenschaften erweitert
              V1.2 - November 1999
              					deutsche Lokalisierung der Komponente und der Dokumentation
              V1.3 - November 1999
              					Untersttzung einer dritten Fremdwhrung
              V1.4 - Januar 2000
												Christophe Foubet (http://perso.wanadoo.fr/cfoubet/)
                       	hat franzsische Strings hinzugefgt
                       Juergen Thomas hat 'ne Menge kommentiert (siehe Textende)
                       	(Ich arbeite dran ;-)
                       Gunther Buchtala hat einen Rundungsfehler entdeckt


   Geschrieben und getestet mit Delphi 3.02

   Sollte mit jeder Delphi Version 3.x und hher funktionieren

		Zweck:
   ======

   	TEuroCalc ist ein Euro-Kalkulator fr bis zu zwei Whrungen
     	gleichzeitig. Sie knnen Euro-Betrge in Mitglieder-
       Whrungen und umgekehrt wandeln. Zustzlich ist die
       Umrechnung in eine Drittwhrung mglich.

   Installation:
   =============

   	In der Menzeile whlen Sie "Komponente" und dort
     	"Komponente installieren...".
     Dann suchen Sie diese Unit und drcken OK.

			Vorsicht: So weit ich weiss, ist in Delphi 5 DSGNINTF.DCU nicht
     					mehr enthalten. Bitte beachten Sie zur weiteren
               Vorgehensweise die Hinweise in der Datei README.TXT
               im Delphi 5 Verzeichnis.

   Verschiedenes:
		==============

   Diese Komponente unterliegt dem Urheberrechtsschutz und
   	ist daher (c) copyrighted 1999-2000 by Robert Wachtel.

   Diese Komponente ist uneingeschrnkte PublicDomain
   	ausschlielich fr private Nutzung!
     ===================================

		Fr jegliche kommerzielle Verwendung ist diese
   	Komponente uneingeschrnkte ShareWare, d.h. sie darf in
     kommerziellen Programmen *nur* nach Zahlung der
     Registrierungsgebhr (s. nchster Absatz) genutzt werden.

   Wenn Sie diese Komponente ntzlich finden und/oder diese
   	Komponenten kommerziell nutzen wollen (also in Programmen,
     die Sie betrieblich und/oder beruflich entwickeln und/oder
     nutzen), senden Sie bitte einen Scheck ber 10 Euro (oder
     US-$ 10) an folgende Adresse:

     	Robert Wachtel
       Kyffhuserstr. 23
       D-50674 Kln
       DEUTSCHLAND

   (Kontoverbindung auf Anfrage)

   Sie erhalten dann das Recht, diese Komponente in kommerziellen
   	Programmen jeder Art einzusetzen (also auch in Programmen,
     die Sie weiter veruern). Dies wird Ihnen dann auch nochmal
     per E-Mail besttigt.

   Gleichzeitig erhalten Sie nach Registrierung neue und/oder
   	fehlerbereinigte und/oder verbesserte Versionen dieser
     Komponente automatisch per E-Mail zugesandt.

   Haben Sie Probleme oder nderungsvorschlge, so stehe ich
   	Ihnen gerne zur Verfgung. ndern Sie diese Software
     oder Teile davon, so bitte ich um bersendung einer
     Kopie dieser nderungen.

		Diese Software wird zur Verfgung gestellt, "wie sie ist", ohne
   	Garantien fr die Funktionsfhigkeit oder korrekte Funktion.
     Der Autor kann nicht fr Datenverlust, Beschdigung, Probleme usw.
     aus der Verwendung dieser Software haftbar gemacht werden.
     (Bemerkung: Diese Einschrnkungen sind notwendig, da beim heutigen
                 Stand der technischen Entwicklungen eine 100%ige
                 Fehlerfreiheit von Software einfach nicht *garantiert*
                 werden kann - alleine schon aus Grnden der
                 Vielfltigkeit der sich auf dem Markt befindlichen
                 Prozessoren, Mainboards, Betriebssystemen usw. und deren
                 Zusammenstellungen. Durch die vollstndige
                 Verfgbarkeit des Quellcodes (OpenSource) ist das
                 Risiko allerdings einschtzbar und die Fehlersuche und
                 -behebung schnell und simpel durchfhrbar.)

		Sie knnen diese Software in jeder Form von Entwicklung einsetzen
   	und sie auch beliebig weitergeben, unter folgenden Voraussetzungen:

			1. Die Herkunft dieser Software mu unmiverstndlich dargestellt
     	 werden. Sie drfen nicht behaupten, da Sie das Original dieser
        Software geschrieben haben. Wenn Sie diese Software in irgend
        einem Produkt einsetzen, setzen Sie bitte in einer Info-Box
        oder in der Dokumentation einen Hinweis in der Form
        			Teile (c) 1999-2000 Robert Wachtel

			2. Sie drfen kein Einkommen aus der Distribution dieses
        Quellcodes an Dritte erzielen. Wenn Sie dieses Produkt
        kommerziell nutzen, drfen Sie den Quellcode dieser
        Software nicht besonders in Rechnung stellen.

			3. Diese Bemerkungen drfen nicht aus diesem Quellcode
        entfernt werden.

     4. Wenn Sie diese Komponente z.B. auf einer Magazin-CD oder
        ShareWare-Sammlung weitergeben, senden Sie mir eine Kopie
        des Mediums zu.

   Credits: (da fllt mir kein passendes deutsches Wort zu ein ;-)
   ========

   Dank an
   	Bea fr all die Liebe
			Simon Reinhardt fr seine DelphiFundgrube (http://pics.webset.de)
   	Lloyd Linklater fr sein "Delphi Notes Help File"
     Sven Biehl fr viele Delphi-Tips
     Alle in news://de.comp.lang.delphi.*

****************************************************************}

unit EuroCalc;

interface

// Delete the following line ({$DEFINE MATH}) if you don't have the math unit
// (i.e. if you have Delphi standard)
//
// Lschen Sie die folgende Zeile ({$DEFINE MATH}), wenn Sie die math unit
// nicht haben (z.B. wenn Sie Delphi Standard besitzen)
{$DEFINE MATH}

// Leave . in language you want
//
// Lassen Sie den Punkt vor der gewnschten Sprache weg
{$DEFINE GERMAN}
{.$DEFINE FRENCH}
{.$DEFINE ENGLISH}

{$IFDEF MATH}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, Math, DsgnIntf;
{$ELSE}
uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, DsgnIntf;
{$ENDIF}

{$IFDEF GERMAN}
type TEuroCountries = (Oesterreich, Belgien, Finnland, Frankreich, Deutschland, Irland, Italien, Luxemburg, Holland, Portugal, Spanien);
// zuknftig: Daenemark, England, Griechenland, Schweden
{$ELSE}
  {$IFDEF ENGLISH}
    type TEuroCountries = (Austria, Belgium, Finland, France, Germany, Ireland, Italy, Luxembourg, Netherlands, Portugal, Spain);
    // for future use: Denmark, GreatBritain, Greece, Sweden
  {$ELSE}
    type TEuroCountries = (Autriche, Belgique, Finlande, France, Allemagne, Irelande, Italie, Luxembourg, Pays_bas, Portugal, Espagne);
    // for future use: Danemark, Grande-Bretagne, Grce, Sude
  {$ENDIF}
{$ENDIF}

type TEuroCurrencies = (ATS, BEF, FIM, FRF, DEM, IEP, ITL, LUF, NLG, PTE, ESP);
// for future use: DKK, GBP, GRD, SEK

type
  TAboutProperty = class(TPropertyEditor)
  public
   procedure Edit; override;
   function GetAttributes: TPropertyAttributes; override;
   function GetValue: string; override;
end;

type
	 TForeignCountry = class(TPersistent)
  private
  	FOwner: TComponent;
   FConversionRate: extended;
   FAmount: currency;
   FInternalAmount: extended;
   FCountryName: string;
   FCurrencyName: string;
   FFixedAfterConversionRateChange: boolean;
   procedure SetConversionRate(rate: extended);
   procedure SetAmount(countryamount: currency);
  public
  	property InternalAmount: extended Read FInternalAmount;
  published
  	property ConversionRate: extended Read FConversionRate Write SetConversionRate;
   property CountryName: string Read FCountryName Write FCountryName;
   property CurrencyName: string Read FCurrencyName Write FCurrencyName;
   property Amount: currency Read FAmount Write SetAmount;
   property FixedAfterConversionRateChange: boolean Read FFixedAfterConversionRateChange Write FFixedAfterConversionRateChange Default true;
end;

type
	 TEuroCountry = class(TPersistent)
  private
  	FOwner: TComponent;
  	FCountry: TEuroCountries;
   FCurrency: TEuroCurrencies;
   FConversionRate: extended;
   FAmount: currency;
   FInternalAmount: extended;
   FCountryName: string;
   FCurrencyName: string;
   procedure SetConversionRate(rate: extended);
   procedure SetCountry(eurocountry: TEuroCountries);
   procedure SetCountryName(eurocountryname: string);
		procedure SetCurrency(eurocurrency: TEuroCurrencies);
   procedure SetCurrencyName(eurocurrencyname: string);
   procedure SetAmount(countryamount: currency);
  public
  	property InternalAmount: extended Read FInternalAmount;
  published
  	property ConversionRate: extended Read FConversionRate Write SetConversionRate;
  	property Country: TEuroCountries Read FCountry Write SetCountry;
   property CountryName: string Read FCountryName Write SetCountryName;
		property Currency: TEuroCurrencies Read FCurrency Write SetCurrency;
   property CurrencyName: string Read FCurrencyName Write SetCurrencyName;
   property Amount: currency Read FAmount Write SetAmount;
end;

type
  TEuroCalc = class(TComponent)
  private
    { Private-Deklarationen }
    FAbout: TAboutProperty;
    FCountry1: TEuroCountry;
    FCountry2: TEuroCountry;
    FForeignCountry: TForeignCountry;
    FEuro: currency;
    FInternalEuro: extended;
    FCountryNames: TStrings;
    FCurrencyNames: TStrings;
    procedure SetEuro(euroamount: currency);
    procedure CalculateCountries;
    procedure SetInternalEuro(const Value: extended);
  protected
    { Protected-Deklarationen }
  public
    { Public-Deklarationen }
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property CountryNames: TStrings Read FCountryNames;
    property CurrencyNames: TStrings Read FCurrencyNames;
  published
    { Published-Deklarationen }
    property InternalEuro: extended Read FInternalEuro Write SetInternalEuro;
    property Euro: currency Read FEuro Write SetEuro;
    property EuroCountry1: TEuroCountry Read FCountry1 Write FCountry1;
    property EuroCountry2: TEuroCountry Read FCountry2 Write FCountry2;
    property ForeignCountry: TForeignCountry Read FForeignCountry Write FForeignCountry;
    property About: TAboutProperty Read FAbout Write FAbout;
end;

{$IFDEF GERMAN}
const _EuroCountries: Array[0..10] of string =
																							('sterreich',
                                              'Belgien',
                                              'Finnland',
                                              'Frankreich',
                                              'Deutschland',
                                              'Irland',
                                              'Italien',
                                              'Luxemburg',
                                              'Holland',
                                              'Portugal',
                                              'Spanien');
// zuknftig: Daenemark, England, Griechenland, Schweden
{$ELSE}
{$IFDEF ENGLISH}
const EuroCountries: Array[0..10] of string =
																							('Austria',
                                              'Belgium',
                                              'Finland',
                                              'France',
                                              'Germany',
                                              'Ireland',
                                              'Italy',
                                              'Luxembourg',
                                              'Netherlands',
                                              'Portugal',
                                              'Spain');
// for future use: Denmark, GreatBritain, Greece, Sweden
{$ELSE}
const EuroCountries: Array[0..10] of string =
																							('Austria',
                                              'Belgique',
                                              'Finlande',
                                              'France',
                                              'Allemagne',
                                              'Irelande',
                                              'Italie',
                                              'Luxembourg',
                                              'Pays-Bas',
                                              'Portugal',
                                              'Espagne');
{$ENDIF}
{$ENDIF}

const _EuroCurrencies: Array[0..10] of string =
																							('ATS',
                                              'BEF',
                                              'FIM',
                                              'FRF',
                                              'DEM',
                                              'IEP',
                                              'ITL',
                                              'LUF',
                                              'NLG',
                                              'PTE',
                                              'ESP');
// for future use: DKK, GBP, GRD, SEK

const _EuroConversionRates: Array[0..10] of extended =
																							(13.7603,
                                              40.3399,
                                              5.94573,
                                              6.55957,
                                              1.95583,
                                             0.787564,
                                              1936.27,
                                              40.3399,
                                              2.20371,
                                              200.482,
                                              166.386);

const _EuroNumericScale: Array[0..10] of ShortInt =
																							(2,0,2,2,2,2,0,0,2,0,0);

const _EuroCalcDefaultNumericScale = 2;

{$IFDEF FRENCH}
const _EuroCalcDefaultCountry = 3; // France / Frankreich
{$ELSE}
const _EuroCalcDefaultCountry = 4; // Germany / Deutschland
{$ENDIF}

const _EuroCalcVersion = '1.4';

{$IFDEF GERMAN}
const _EuroErrorCountryName = 'EuroCalc' + #13#13 + 'Ungltiger Wert:' + #13 + 'Land unbekannt!';
const _EuroErrorCurrencyName = 'EuroCalc' + #13#13 + 'Ungltiger Wert:' + #13 + 'Whrung unbekannt!';
{$ELSE}
{$IFDEF ENGLISH}
const _EuroErrorCountryName = 'EuroCalc' + #13#13 + 'Value out of Range:' + #13 + 'Country not recognized!';
const _EuroErrorCurrencyName = 'EuroCalc' + #13#13 + 'Value out of Range:' + #13 + 'Currency not recognized!';
{$ELSE}
const _EuroErrorCountryName = 'EuroCalc' + #13#13 + 'Valeur hors limites:' + #13 + 'Pays non reconnu!';
const _EuroErrorCurrencyName = 'EuroCalc' + #13#13 + 'Valeur hors limites:' + #13 + 'Monnaie non reconnue!';
{$ENDIF}
{$ENDIF}

procedure Register;

function FinancialRound(amount: currency; numericscale: ShortInt): currency;

implementation

//********** RegisterComponent **********
// Register the component in the palette
procedure Register;
begin
  RegisterComponents('MPS', [TEuroCalc]);
  RegisterPropertyEditor(TypeInfo(TAboutProperty), TEuroCalc, 'About', TAboutProperty);
end;

//********** TAboutProperty.Edit **********
procedure TAboutProperty.Edit;
begin
  ShowMessage('EuroCalc Component v' + _EuroCalcVersion + #13#13 +
  				     ' Copyright 1999-2000 by Robert Wachtel, all rights reserved.' + #13#13 +
              '   eMail rwachtel@gmx.de   http://www.mpscologne.de');
end;

//**************************************************
// TAbout
//**************************************************

//********** TAboutProperty.GetAttributes **********
function TAboutProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paMultiSelect, paDialog, paReadOnly];
end;

//********** TAboutProperty.GetValue **********
function TAboutProperty.GetValue: string;
begin
  Result := 'About...';
end;

//**************************************************
// TEuroCountry
//**************************************************

//********** TEuroCountry.SetConversionRate **********
procedure TEuroCountry.SetConversionRate(rate: extended);
begin
end;

//********** TEuroCountry.SetCountry **********
procedure TEuroCountry.SetCountry(eurocountry: TEuroCountries);
begin
 FCountry := eurocountry;
 FCurrency := TEuroCurrencies(Ord(FCountry));
 FConversionRate := _EuroConversionRates[Ord(FCountry)];
 FCountryName := _EuroCountries[Ord(FCountry)];
 FCurrencyName := _EuroCurrencies[Ord(FCountry)];
 if FOwner <> nil then
 begin
  	FInternalAmount := TEuroCalc(FOwner).FInternalEuro * FConversionRate;
   FAmount := FinancialRound(FInternalAmount, _EuroNumericScale[Ord(Fcountry)]);
 end;
end;

//********** TEuroCountry.SetCurrency **********
procedure TEuroCountry.SetCurrency(eurocurrency: TEuroCurrencies);
begin
 Country := TEuroCountries(Ord(eurocurrency)); // set country / Land setzen
end;

//********** TEuroCountry.SetAmount **********
procedure TEuroCountry.SetAmount(countryamount: currency);
begin
	FAmount := FinancialRound(countryamount, _EuroNumericScale[Ord(Fcountry)]);
 FInternalAmount := FAmount;
 if FOwner <> nil then
 begin
 	TEuroCalc(FOwner).FInternalEuro := FInternalAmount / FConversionRate;
   TEuroCalc(FOwner).FEuro := FinancialRound(TEuroCalc(FOwner).FInternalEuro, _EuroCalcDefaultNumericScale);
   TEuroCalc(FOwner).CalculateCountries;
 end;
end;

//********** TEuroCountry.SetCountryName **********
procedure TEuroCountry.SetCountryName(eurocountryname: string);
var
	i: TEuroCountries;
 error: boolean;
begin
	error := true;
	for i := Low(TEuroCountries) to High(TEuroCountries) do
		if eurocountryname = _EuroCountries[Ord(i)] then
   begin
			Country := i;
     error := false;
     break;
   end;
 	if error then
   	raise ERangeError.Create(_EuroErrorCountryName);
end;

//********** TEuroCountry.SetCurrencyName **********
procedure TEuroCountry.SetCurrencyName(eurocurrencyname: string);
var
	i: TEuroCurrencies;
 error: boolean;
begin
	error := true;
	for i := Low(TEuroCurrencies) to High(TEuroCurrencies) do
		if eurocurrencyname = _EuroCurrencies[Ord(i)] then
   begin
			Currency := i;
     error := false;
     break;
   end;
 	if error then
   	raise ERangeError.Create(_EuroErrorCurrencyName);
end;

//**************************************************
// TEuroCalc
//**************************************************

//********** TEuroCalc.Create **********
constructor TEuroCalc.Create(AOwner: TComponent);
var
	i: integer;
begin
	inherited Create(AOwner);
 FCountry1 := TEuroCountry.Create;
 FCountry1.FOwner := self;
 FCountry1.Country := TEuroCountries(_EuroCalcDefaultCountry);
 FCountry2 := TEuroCountry.Create;
 FCountry2.FOwner := self;
 FCountry2.Country := TEuroCountries(_EuroCalcDefaultCountry);
 FForeignCountry := TForeignCountry.Create;
 FForeignCountry.FOwner := self;
	FCountryNames := TStringList.Create;
 FCurrencyNames := TStringList.Create;
 for i := Low(_EuroCountries) to High(_EuroCountries) do
 	FCountryNames.Add(_EuroCountries[i]);
 for i := Low(_EuroCurrencies) to High(_EuroCurrencies) do
 	FCurrencyNames.Add(_EuroCurrencies[i]);
end;

//********** TEuroCalc.SetEuro **********
// Amount of Euros changed by User
// Euro-Betrag wurde gendert
procedure TEuroCalc.SetEuro(euroamount: currency);
begin
	FEuro :=	FinancialRound(euroamount, _EuroCalcDefaultNumericScale);
 FInternalEuro := FEuro;
 CalculateCountries;
end;

//********** TEuroCalc.SetInternalEuro **********
procedure TEuroCalc.SetInternalEuro(const Value: extended);
begin
end;

//********** TEuroCalc.CalculateCountries **********
// Calculate countrie's amounts after change of Euro
// Landeswhrungen nach nderung des Euro-Betrags aktualisieren
procedure TEuroCalc.CalculateCountries;
begin
 FCountry1.FInternalAmount := FInternalEuro * FCountry1.FConversionRate;
 FCountry1.FAmount := FinancialRound(FCountry1.FInternalAmount, _EuroNumericScale[Ord(FCountry1.Fcountry)]);
 FCountry2.FInternalAmount := FInternalEuro * FCountry2.FConversionRate;
 FCountry2.FAmount := FinancialRound(FCountry2.FInternalAmount, _EuroNumericScale[Ord(FCountry2.Fcountry)]);
 FForeignCountry.FInternalAmount := FInternalEuro * FForeignCountry.FConversionRate;
 FForeignCountry.FAmount := FinancialRound(FForeignCountry.FInternalAmount, _EuroCalcDefaultNumericScale);
end;

//********** TEuroCalc.Destroy **********
destructor TEuroCalc.Destroy;
begin
	FCountry1.Free;
 FCountry1 := nil;
	FCountry2.Free;
 FCountry2 := nil;
 FForeignCountry.Free;
 FForeignCountry := nil;
 FCountryNames.Free;
 FCountryNames := nil;
 FCurrencyNames.Free;
 FCurrencyNames := nil;
	inherited Destroy;
end;

//**************************************************
// TForeignCountry
//**************************************************

//********** TForeignCountry.SetAmount **********
procedure TForeignCountry.SetAmount(countryamount: currency);
begin
	FAmount := FinancialRound(countryamount, _EuroCalcDefaultNumericScale);
 FInternalAmount := FAmount;
 if FOwner <> nil then
 begin
 	if FConversionRate <> 0 then
 		TEuroCalc(FOwner).FInternalEuro := FInternalAmount / FConversionRate
   else
 		TEuroCalc(FOwner).FInternalEuro := 0;
   TEuroCalc(FOwner).FEuro := FinancialRound(TEuroCalc(FOwner).FInternalEuro, _EuroCalcDefaultNumericScale);
   TEuroCalc(FOwner).CalculateCountries;
 end;
end;

//********** TForeignCountry.SetConversionRate **********
procedure TForeignCountry.SetConversionRate(rate: extended);
begin
	FConversionRate := rate;
 if FFixedAfterConversionRateChange then
 	SetAmount(FAmount)
 else
 	TEuroCalc(FOwner).CalculateCountries;
end;

//**************************************************
// Procedures and Functions
//**************************************************

//********** FinancialRound **********
function FinancialRound(amount: currency; numericscale: ShortInt): currency;
begin
 Result := StrToCurr(CurrToStrF(amount, ffFixed, numericscale));
end;

(**************************************************************
   24.01.2000  Anmerkungen von Jrgen Thomas zur knftigen Erweiterung
               e-Mail: vs-polis@t-online.de

Flexible Behandlung von ,Euroland'
----------------------------------
Die vorstehende Gestaltung hat den Nachteil, dass bei jeder Erweiterung von Euroland
die darauf basierenden Programme neu kompiliert werden mssen und bei den Endanwendern
neu installiert werden mssen. Dies ist natrlich unpraktisch. Ich schlage deshalb
eine andere Grundstruktur vor (im Folgenden steht nur eine ,Grobbeschreibung', aber
noch keine ausformulierten Pascal-Deklarationen):

type TEuroCountry:
     FCountryName, FCurrencyName: string;
     FConversionRate: extended;
     FNumericScale: shortint;
     FUebergangszeit: TDate;
     //  wegen spter hinzu kommender 'Euro-Lnder' bentigt jedes Land ein
     //  eigenes Ende der bergangszeit mit Doppelwhrung

type TEuroCalc:
     property Countries: array of TEuroCountry;
     procedure AddCountry;
     property IniFile: string;
     property IniSection: string;

Default-Werte, wenn IniFile oder IniSection nicht angegeben werden oder nicht
existieren:
     IniFile := ChangeFileExt( Application.ExeName, '.INI' );
     IniSection := 'EuroCountries';
     DE.Name=Deutschland
     DE.Whrung=DM
     DE.Kurs=1.95583
     DE.Genauigkeit=2
     DE.bergangszeit=28.02.2002
     //  usw. die brigen Lnder entsprechend den obigen const-Werten

Whrend OnCreate werden aus dem IniFile alle Strings von [IniSection] eingelesen
und umgesetzt; mit diesen Werten wird das array Countries gefllt. Die Werte stehen
dort in der obigen Form des obigen Beispiels. Dabei bezeichnet DE das Lnderkrzel
gem ISO 3166; die zugeordneten Werte ergeben sich zwangslufig aus den Bedrfnissen
der Euo-Umrechnung, ermglichen aber eine variable Bezeichnung von Land und Whrung
und ermglichen auch 'individuelle' Bearbeitung spterer Euro-Beitritte.

In einem Anwendungsprogramm kann dann auch eine andere Whrung (was ist z.B. mit den
knftigen EU-Mitgliedern in Mittel- und Osteuropa?) hinzugefgt werden; natrlich
sollte sicher gestellt werden, dass nderungen danach nicht mehr vorgesehen sind.

Problem: Zuordnung und automatische Umrechnung zu Feldern
         (TEdit, TspinEdit, Datenbanken usw.)
---------------------------------------------------------
Es wre uerst praktisch, wenn man eine automatische Umrechnung zu solchen Werten
angeben knnte; ich sehe dazu aber nur die Mglichkeit von abgeleiteten Komponenten
wie TEditEuro - und das wre nur fr die bergangszeit bis 28.02.2002 zu groer
Aufwand.

Sinnvoll wre es, wenn jede solcher Komponenten Eingabewert und Eingabe-/
Anzeigewhrung kennen wrde und auerdem eine EuroCalc-Komponente zugeordnet
wrde; OnChange oder OnExit wrde dann automatisch aus dem Eingabewert den internen
Euro-Wert und die zugeordneten Werte Country1.Value und Country2.Value ableiten.

Fr eine solche Lsung habe ich mir bisher folgende Gedanken gemacht; dabei mssten
Sie bercksichtigen, dass ich Info Power 2000 von Woll2Woll Software benutze
(Informationen dazu: (a) Der Entwickler Nr. 4/1999 S.40 ff.; (b) www.woll2woll.com):

Grundstzlich werden Betrge nur als Euro-Werte gespeichert; fr die Anzeige und
ggf. bei Eingaben sind Umrechnungen vorzusehen. Alle Tabellen, fr die diese Manahmen
wichtig sind, knnten (soweit mglich) in einem Datenmodul dm zusammengefasst werden.

**  Globale Variable
    euroAktiv:   Boolean;   //  Anzeige und Eingabe gilt in Euro
    euroLand:    string;    //  fr die Arbeit in Deutschland 'DE'
    euroWichtig: Boolean;   //  wird abgeleitet aus der Ini-Datei, fr DE
                            //  also vermutlich bis 28.02.2002 auf True, danach auf False

**  dm.tblXXX.OnOpen
    (nach Prfung, wann die Felddefinitionen bekannt sind, wird dies fr
    BeforeOpen oder AfterOpen vorgesehen):
fr jedes Feld mit ftCurrency wird ein CalcField erzeugt mit:
    FieldName := Feld.Tabelle + Feld.Name + 'XX'
    //  nicht DM, falls mein Programm z.B. in Dnemark installiert wird
Alle diese Felder werden in eine zustzliche Stringliste zu tblXXX eingetragen, so
dass ich schnell die Zuordnungen ablesen kann.
CalcFields := euroWichtig;  //  sofern es Felder mit ftCurrency gibt, sonst gezielt festlegen

**  Es ist zu berlegen, ob diese CalcFields zur Laufzeit automatisch erzeugt werden
    sollen oder doch besser manuell im Feldeditor von Delphi definiert werden sollten.

**  OnCalcFields errechnet immer aus dem Euro-Betrag den Betrag der Nebenwhrung,
    aber nur dann, wenn dieses Feld nicht soeben als DM-Betrag eingegeben und in
    Euro umgerechnet wurde (siehe die Hinweise auf die Eingabefelder).

**  Eingabefelder sind in der Regel TwwDBEdit mit Zuordnung eines Betragsfeldes.
    if EuroAktiv
    then edit.FieldName := FeldName
    else edit.FieldName := FeldNameXX;
OnExit bearbeitet auf jeden Fall:
    if not EuroAktiv     then dm.euroWertAnpassen( edit );

Sicherer wre OnChange, aber dies wrde whrend der Eingabe mehrmals (fr jede einzelne
Ziffer) ausgefhrt und knnte die Zusatzprfung wegen der Rundungsdifferenz nicht
bercksichtigen. Deshalb muss ich dafr OnExit verwenden.

Eine einheitliche Funktion wre noch schner, geht aber nur fr die Felder, die keine
weiteren Prfungen nach sich ziehen; es ist nicht mglich z.B. fr den Zahlungseingang.

Registriere alle diese Felder in einer zustzlichen Liste; dann brauche ich beim
Umschalten nur diese Felder zu bearbeiten und muss nicht alle Komponenten des Formulars
prfen.

**  dm.euroWertAnpassen(edit: TwwDBEdit) erledigt Folgendes:
    (a)  Sichere den eingegebenen DM-Betrag.
    (b)  Suche zu dem aktuellen CalcField edit ber die euro-Stringliste von tblXXX
         das 'Originalfeld'.
    (c)  Berechne daraus den Euro-Betrag.
    (d)  Wenn im Originalfeld bereits ein Betrag steht und dieser um mehr als 0,01
         vom errechneten Betrag abweicht, wird der errechnete Betrag eingetragen.
    (e)  Durch OnCalcFields wird der errechnete Betrag wieder in DM umgerechnet;
         falls dieser vom gesicherten DM-Betrag (siehe a) abweicht, wird der
         ursprnglich eingegebene Wert wieder eingetragen. (Da ich nicht OnChange,
         sondern OnExit verwende, fhrt das nicht zu einer Rekursivschleife.)

**  TwwDBGrids erhalten als Feldberschrift immer neutrale Namen; in Selected stehen
    diese neutralen Bezeichnungen und die Hinweise auf das jeweils gewnschte Feld
    in Abhngigkeit von euroAktiv. Dadurch werden automatisch immer die richtigen
    Werte angezeigt, die mit der aktuellen Aktivierung von Euro bzw. DM bereinstimmen.

**  Zustzlich bentige ich eine Stringliste, die alle diese Grids mit Umschaltung
    DM/Euro nennt (siehe das Verfahren der Umschaltung).

**  Das Umschalten DM/Euro erfolgt durch zwei Menpunkte mit Check-Funktion oder durch
    einen ToolButton oder durch einen speziellen Button mit Beschriftung. Dabei werden
    ausgefhrt:
    **  Fr alle Grids, die in der eben genannten Stringliste stehen werden die Eintrge
        in Selected geprft: Sofern es sich um ein ftCurrency-Feld handelt, wird das
        gem der Liste von tblXXX vorgesehene 'andere' Feld eingetragen.
    **  Fr alle TwwDBEdit-Felder, die in der obigen Stringliste stehen, werden das
        bisherige Feld durch das gem der Liste von tblXXX vorgesehene 'andere' Feld
        ersetzt.

Problem: Umrechnungsdifferenzen
-------------------------------
Die zwangslufigen Umrechnungsdifferenzen sind in der vorstehenden Lsung nicht
bercksichtigt. Ich nehme aber an, dass die Verfahren, wie diese Differenzen zu
verarbeiten sind, immer von der jeweiligen Anwendung abhngen; diese Verfahren
knnen also wohl nicht in einer allgemeinen Komponente bercksichtigt werden.

Die folgenden Anwendungsprobleme erwhne ich deshalb nur der Vollstndigkeit halber.

**  Rechnung wird noch in DM gebucht, aber Zahlung erfolgt in Euro. Beispiel:
    Rechnung wird in DM erzeugt mit einem Rechnungsbetrag von 28,00 DM und auch
    in dieser Whrung gespeichert.
    Anwender druckt und verschickt die Rechnung und gibt dabei an:
             Rechnungsbetrag 28,00 DM
             umgerechnet     14,32 Euro
    Zahler berweist nun 14,32 Euro.
    Anwender will also den Zahlungseingang buchen:
             Zahlungsbetrag  14,32 Euro
             umgerechnet     28,01 DM
    Nun gibt es das Problem, wie diese Differenz bercksichtigt werden soll.

**  Ein hnliches Problem kann auftreten, wenn eine Rechnung in zwei oder mehr
    Teilbetrgen bezahlt wird. Je nachdem, an welcher Stelle zwischen Euro und
    DM umgerechnet wird, kann die Summe der umgerechneten Betrgen und Restbetrge
    vom ursprnglichen Wert abweichen.

**************************************************************)

end.
